<?php

// Pour importer des auteurs depuis un fichier .csv
// Yves Tannier - http://www.grafactory.net - GPL ect...

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/auteur_voir');
include_spip('inc/acces');
include_spip('base/abstract_sql');

function exec_auteurs_import_dist()
{
    global $connect_statut, $connect_login, $connect_toutes_rubriques, $couleur_foncee, $flag_gz, $options;

    debut_page("Importation d'une liste d'auteurs", "administration", "base");
 
     // etre admin tu dois
     if ($connect_statut != '0minirezo' ){
        echo _T('avis_non_acces_page');
        fin_page();
        exit;
     }

    echo "<br /><br />";
	gros_titre("Importer des auteurs");
    
    debut_gauche();

    debut_boite_info();
        echo propre("{{Cette page est uniquement accessible aux responsables du site.}}<P> Elle donne acc&egrave;s aux diff&eacute;rentes
        fonctions de maintenance technique. Certaines d'entre elles donnent lieu &agrave; un processus d'authentification sp&eacute;cifique, qui
        exige d'avoir un acc&egrave;s FTP au site Web.");
    fin_boite_info();

    debut_droite();

    debut_cadre_relief();

    echo "<table border=\"0\" cellspacing=\"1\" cellpadding=\"8\" width=\"100%\">";
    echo "\n<tr><td bgcolor='$couleur_foncee' background=''>";
    echo "<span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 14px; font-weight: bold; color:#FFFFFF;\">";
    echo "Importer un liste d'auteurs</span></td></tr>";

    echo "<tr><td background=''>";

    // champs
    $champs = array('Nom','Bio','Email','Nom du site','Url du site','PGP','Login','Mot de passe','Statut');
    
    // fichier auteur
    $liste_auteurs = "liste_auteurs.csv";
    
    // fichier auteur a telecharger
    $liste_auteurs_final = "liste_auteurs_final.csv";
    
    // chemin
    $chemf = "data/";
    
    // chemin ou on met le fichier final
    $chemff = "upload/";

    // info chemin (uniquement pour infos sur la page)
    $info_chemin = "/ecrire/data/";
 
    //  caracteres speciaux
    $Caracs = array("" => "Y", "" => "u", "" => "A", "" => "A",
    "" => "A", "" => "A", "" => "A", "" => "A",
    "" => "A", "" => "C", "" => "E", "" => "E",
    "" => "E", "" => "E", "" => "I", "" => "I",
    "" => "I", "" => "I", "" => "D", "" => "N",
    "" => "O", "" => "O", "" => "O", "" => "O",
    "" => "O", "" => "O", "" => "U", "" => "U",
    "" => "U", "" => "U", "" => "Y", "" => "s",
    "" => "a", "" => "a", "" => "a", "" => "a",
    "" => "a", "" => "a", "" => "a", "" => "c",
    "" => "e", "" => "e", "" => "e", "" => "e",
    "" => "i", "" => "i", "" => "i", "" => "i",
    "" => "o", "" => "n", "" => "o", "" => "o",
    "" => "o", "" => "o", "" => "o", "" => "o",
    "" => "u", "" => "u", "" => "u", "" => "u",
    "" => "y", "" => "y");

    // function pour generer les logins
    // login  partir du nom sans caractre spciaux et 10 caracteres maximum
    function faireLogin($str=null,$Caracs=null) {
        
        $login = strip_tags($str);
        $login  = strtr($login, $Caracs); 
        $login  = eregi_replace("[^a-z0-9]", "", $login); 
        $login = strtolower($login);
        
        // limitation de la taille du login
        if (strlen($login) > 10) {
            $login = substr($login, 0, 10);
        }

        return $login;
    }
    
    // fonction qui gnre un mot de passe
    function MDP() {
        
        $chrs = 8;
        $pwd = ""  ;

        mt_srand ((double) microtime() * 1000000);
        
        while (strlen($pwd)<$chrs) {
         $chr = chr(mt_rand (0,255));
         if (eregi("^[a-hj-km-np-z2-9]$", $chr))
         $pwd = $pwd.$chr;
        }
                        
        return strtolower($pwd);
    }

    // supprimer le fichier csv genere dans /ecrire/upload car il contient les mots de passe
    if(isset($_GET['supprliste']) && $_GET['supprliste']==1) {
        if(@unlink($chemff.$liste_auteurs_final)) {
            echo "<p style=\"color: red; font-weight: bold; text-align: justify;\">Le fichier ".$liste_auteurs_final." g&eacute;n&eacute;r&eacute; dans /ecrire/upload/ a bien &eacute;t&eacute; supprim&eacute;";
        } else {
            echo "<p style=\"color: red; font-weight: bold; text-align: justify;\">ATTENTION : probl&egrave;me dans la suppression du fichier ".$liste_auteurs_final." g&eacute;n&eacute;r&eacute; dans /ecrire/upload/. 
                    Veuillez le supprimer manuellement.";
        }
    }

    // message avant chargement
    if(!isset($_GET['action'])) {

        echo "\n<p align=\"justify\">Vous pouvez importer une liste d'auteurs &agrave; partir d'un fichier au format .CSV (Comma Separted Value).<br /><br /> 
                Ce type de fichier peut-&ecirc;tre obtenu &agrave; partir d'un fichier de type Excel. Consultez la documentation de votre tableur pour savoir comment enregistrer dans se format.<br /><br />
                Un conseil, <span style=\"color: red;\">fa&icirc;tes une sauvegarde de votre base de donn&eacute;es avant toutes choses</span>.<br /><br />
                <strong>Vous devez ensuite placer le fichier ".$liste_auteurs." que vous aurez cr&eacute;&eacute; dans le r&eacute;pertoire ".$info_chemin."</strong>.</p>";

        echo "\n<form id=\"importauteur\" method=\"get\">";
        echo "\n<p>Caract&egrave;re de s&eacute;paration des champs : <input type=\"text\" name=\"separateur\" value=\";\" size=\"1\" /><br />";
        echo "\n<input type=\"checkbox\" name=\"same_as_login\" value=\"1\" /> Mettre le nom d'utilisateur comme mot de passe ?<br />";
        echo "\n<input type=\"checkbox\" name=\"generer_csv\" value=\"1\" /> R&eacute;cup&eacute;rer un fichier CSV des r&eacute;sultats ?</p>";
        echo "\n<p><input type=\"hidden\" name=\"action\" value=\"importcsv\" /><input type=\"hidden\" name=\"exec\" value=\"auteurs_import\" />";
        echo "\n<input type=\"submit\" name=\"valider\" value=\"Cr&eacute;er la liste\" /></p>";
        echo "\n</form>";

        echo "\n<p style=\"text-align: justify\">Note importante : le fichier ".$liste_auteurs_final." g&eacute;n&eacute;r&eacute; sera stock&eacute; dans /ecrire/upload/. 
        <span style=\"color: red; font-weight: bold;\">Veuillez le supprimer car il contient les mots de passe en clair</span></p>";

        echo "</td></tr>";
        echo "</table>";
        fin_cadre_relief();
    }

    // on y va !!!
    if ($_GET['action'] == "importcsv") {

        // generer csv ?
        if(isset($_GET['generer_csv']) && $_GET['generer_csv']==1) {
            $generer_csv = 1;
        } else {
            $generer_csv = null;
        }

        // fichier a convertir
        $nom_fichier = $chemf.$liste_auteurs;

        // caractere de separation
        if(isset($_GET['separateur']) && !empty($_GET['separateur'])) {
            $separateur = $_GET['separateur'];
        } else {
            $separateur = ";";
        }

        // on ne trouve pas le fichier
        if (!file_exists($nom_fichier)) {
            echo  "<p><span style='color: red; font-weight: bold;'>Le fichier ".$liste_auteurs." est introuvable dans le r&eacute;pertoire ".$info_chemin." !</span></p>";
            echo "</td></tr>";
            echo "</table>";
            fin_cadre_relief();
        }
        else {
            
            echo  "<p><span style='color: red; font-weight: bold;'>R&eacute;sultats</span>";
            echo "\n (<a href=\"?exec=auteurs_import\">retour au choix</a>)</p>";
            
            // telecharger le fichier csv
            if(!empty($generer_csv)) {
                echo "\n<p><a href=\"".$chemff.$liste_auteurs_final."\"><img src=\"img_pack/icones/ods-dist.png\" alt=\"\" style=\"vertical-align:middle; float: left; padding-right: 3px;\" />
                &nbsp;R&eacute;cup&eacute;rer un fichier au format CSV</a> de ce tableau<br /><br />";
                echo "\nUne fois r&eacute;cup&eacute;r&eacute;, <a href=\"?exec=auteurs_import&supprliste=1\" style=\"color: red;\">supprimer le fichier</a> (contient les mots de passe en clair)</p>";
            }
            
            echo "</td></tr>";
            echo "</table>";
            fin_cadre_relief();
            
            // on ouvre le fichier trouve en lecture
            $fp = fopen($nom_fichier,  "r");
                       // tableau en html
            echo "<table border=\"1\" cellspacing=\"1\" cellpading=\"9\" width=\"100%\" bordercolor=\"#000\" style=\"background: #fff;\">";

            // entete du tableau
            echo "\n<tr style=\"font-family: Verdana, sans-serif; font-size: 10px; font-weight: bold;\">";

            // entete du tableau HTML
            foreach($champs as $v) {
                echo "\n<td>".$v."</td>";
            }

            // entete du tableau csv
            if(!empty($generer_csv)) {
                $entete = null;
                foreach($champs as $v) {
                    $entete .= $v.$separateur;
                }
            }

            // tableau csv
            $infos = $entete;

            // parcours du fichier
            while (!feof($fp)) {
                
                $ligne = fgets($fp,4096);  // On se dplace d'une ligne
                $liste = explode($separateur,$ligne);  // Champs spars

                // les valeur du fichier
                $nom = $liste[0]; // nom colonne 1
                $bio = $liste[1]; // bio colonne 2
                $email = $liste[2]; // mail colonne 3
                $nom_site = $liste[3]; // nom du site colonne 4
                $url_site = $liste[4]; // url du site colonne 5
                $pgp = $liste[5]; // cle PGP colonne 6
                $type_acces = $liste[6]; // type d'acces colonne 7

                // si pas de type acces, on met le statut redacteur
                if(empty($type_acces)) {
                    $type_acces = "1comite";
                }

                // si il y a une colonne 8 alors c'est le login
                if(isset($liste[7]) && !empty($liste[7])) {
                    $login = $liste[7];
                }

                // si il y a une colonne 9 alors c'est le mot de passe
                if(isset($liste[8]) && !empty($liste[8])) {
                    $new_pass = $liste[8];
                }
                    
                $nom = trim($nom); // enlever les espaces en trop dans le nom

                // si le nom existe, on genere le login
                if (!empty($nom)) {

                    // genrer le login = cf. fonction du haut
                    if(empty($login)) {
                        $login = faireLogin($nom,$Caracs);
                    }
                    
                    // verifier si le login est deja pris 
                    $n = spip_fetch_array(spip_query("SELECT COUNT(*) AS n FROM spip_auteurs WHERE login='".$login."' AND statut!='5poubelle'"));
                    // si deja pris
                    if ($n['n']) {
                        // un recap  l'cran
                        echo "\n<tr style=\"font-family: Verdana, sans-serif; font-size: 10px;\">";
                        echo "\n<td>".$nom."</td>";
                        echo "\n<td colspan=\"8\" style=\"color: red;\">L'utilisateur ".$login." est d&eacute;j&agrave; enregistr&eacute;</td>";
                        echo "\n</tr>"; 
                    } else { // sinon
                            
                        $nom = addslashes($nom);
                        $bio = addslashes($bio);
                        $nom_site = addslashes($nom_site);
                        $url_site = addslashes($url_site);
                            
                        // mot de passe identique au login ?
                        if(isset($_GET['same_as_login']) && $_GET['same_as_login']==1) {
                            $new_pass = $login;
                        }

                        // si pas de mot de passe, on le genere avec la fonction
                        if(!isset($new_pass)) {
                            $new_pass = MDP();
                        }
                            
                        // les trucs de spip ;)		
                        $htpass = generer_htpass($new_pass);
                        $alea_actuel = creer_uniqid();
                        $alea_futur = creer_uniqid();
                        $pass = md5($alea_actuel.$new_pass);
                        
                        // un recaptulatif  l'cran sous forme de tableau HTML
                        echo "\n<tr style=\"font-family: Verdana, sans-serif; font-size: 10px;\">";
                        echo "\n<td>".$nom."</td>";
                        if (!empty($bio)) { echo "\n<td>".$bio."</td>"; } else { echo "<td>&nbsp;</td>"; }
                        if (!empty($email)) { echo "\n<td>".$email."</td>"; } else { echo "<td>&nbsp;</td>"; } 
                        if (!empty($nom_site)) { echo "\n<td>".$nom_site."</td>"; } else { echo "<td>&nbsp;</td>"; } 
                        if (!empty($url_site)) { echo "\n<td>".$url_site."</td>"; } else { echo "<td>&nbsp;</td>"; } 
                        if (!empty($pgp)) { echo "\n<td>".$pgp."</td>"; } else { echo "<td>&nbsp;</td>"; } 
                        if (!empty($login)) { echo "\n<td>".$login."</td>"; } else { echo "<td>&nbsp;</td>"; } 
                        if (!empty($new_pass)) { echo "\n<td>".$new_pass."</td>"; } else { echo "<td>&nbsp;</td>"; }
                        echo "\n<td>".$type_acces."</td>";
                        echo "\n</tr>"; 
                        
                        // infos pour le fichier csv en sortie
                        if(!empty($generer_csv)) {
                            $infos .= "\r".$nom.$separateur.$bio.$separateur.$email.$separateur.$nom_site.$separateur.$url_site.$separateur.$pgp.$separateur.$login.$separateur.$new_pass.$separateur.$type_acces;
                        }

                            // insertion dans la base des infos avec le login, le mot de passe ect...
                            $query = "INSERT INTO spip_auteurs (nom,login,bio,email,nom_site,url_site,pgp,statut,pass,htpass,alea_actuel,alea_futur) VALUES
                                ('$nom',
                                '$login',
                                '$bio',
                                '$email',
                                '$nom_site',
                                '$url_site',
                                '$pgp',
                                '$type_acces',
                                '$pass',
                                '$htpass',
                                '$alea_actuel',
                                '$alea_futur')";
                            // execution de la requete
                            spip_query($query) OR die($query);
                    }

                }
                
                // remettre login et mdp a null pour la boucle
                $login = null;
                $new_pass = null;
            }
            // fermeture du fichier
            fclose($fp);

            // mettre les infos dans un fichier csv
            if(!empty($generer_csv)) {
                $pointeur = fopen($chemff.$liste_auteurs_final,'w+');
                fwrite($pointeur, $infos);
                fclose($pointeur);
            }
        
            echo "</table>";

        }

    }			 

    fin_page();

}
?>
